/* Centaur Chirp
 * Version 1.3
 * 10/10/2020
 *
 * Functions to generate tones through the PC speaker
 *
 * init_freq()		-- Initialize the frequency and symbol arrays
 * seek_tonechar(char)	-- Return the appropriate frequency for a single character
 * exec_tonechar 
 * (Freq, Length, Times, Delay)
 * 			-- Generate a single tone
 * tonestr(string)	-- Generate a tone for each character in a string
 *
 * chirp.c
 */
 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "chirp.h"

void init_freq(void)
{
	int ix;
	for (ix = 0; ix < strlen(SYMBOLS); ix++)
	{
		FREQ[ix] = SYMBOLS[ix];
	}
	return;
};

int seek_tonechar(char ch)
{
	char R;
	char *rx;
	rx = strchr(SYMBOLS, ch);
	R = rx - SYMBOLS;
	return (FREQ[R] + Freq_Adj);
}

void exec_tonechar(int Freq, int Length, int Times, int Delay)
{
	char cmd[64];
	sprintf(cmd, "%s -f %d -l %d -r %d -d %d", TONE_SHELL_COMMAND, Freq, Length, Times, Delay);
	system(cmd);
	return;
}

void tonestr(char string[])
{
	int cx;
	int ix;
	for (ix = 0; ix < strlen(string); ix++)
	{
		cx = seek_tonechar(string[ix]);
		exec_tonechar(cx, init_pack.length, init_pack.times, init_pack.delay);
	}
	return;
}
